extends MeshInstance

export (float) var height = 2.0

var ws : float = 0.0
var reference : Transform = Transform()

func _ready():
	# todo subscribe to our play area changed signal
	pass

func _process(delta):
	# if either of these change, our play area needs to be adjusted.
	var new_ws = ARVRServer.world_scale
	var new_reference = ARVRServer.get_reference_frame()
	
	if ws!=new_ws or reference!=new_reference:
		var oculus_config = get_parent().get_config()
		if !oculus_config:
			# can't update this yet
			return
		
		if !oculus_config.play_area_available():
			# can't update this yet
			return
		
		# get our play area, ws and our reference frame have already been applied
		var play_area = oculus_config.get_play_area()
		var h = Vector3(0.0, height, 0.0)
		
		var st = SurfaceTool.new()
		st.begin(Mesh.PRIMITIVE_TRIANGLES)
		
		# floor
		st.add_uv(Vector2(0,0))
		st.add_vertex(play_area[0])
		st.add_uv(Vector2(1,0))
		st.add_vertex(play_area[1])
		st.add_uv(Vector2(1,1))
		st.add_vertex(play_area[2])
		st.add_uv(Vector2(0,0))
		st.add_vertex(play_area[0])
		st.add_uv(Vector2(1,1))
		st.add_vertex(play_area[2])
		st.add_uv(Vector2(0,1))
		st.add_vertex(play_area[3])
		
		# ceiling
		st.add_uv(Vector2(0,0))
		st.add_vertex(play_area[0] + h)
		st.add_uv(Vector2(1,1))
		st.add_vertex(play_area[2] + h)
		st.add_uv(Vector2(1,0))
		st.add_vertex(play_area[1] + h)
		st.add_uv(Vector2(0,0))
		st.add_vertex(play_area[0] + h)
		st.add_uv(Vector2(0,1))
		st.add_vertex(play_area[3] + h)
		st.add_uv(Vector2(1,1))
		st.add_vertex(play_area[2] + h)
		
		# side A
		st.add_uv(Vector2(0,0))
		st.add_vertex(play_area[0])
		st.add_uv(Vector2(1,0))
		st.add_vertex(play_area[0] + h)
		st.add_uv(Vector2(1,1))
		st.add_vertex(play_area[1] + h)
		st.add_uv(Vector2(0,0))
		st.add_vertex(play_area[0])
		st.add_uv(Vector2(1,1))
		st.add_vertex(play_area[1] + h)
		st.add_uv(Vector2(0,1))
		st.add_vertex(play_area[1])
		
		# side B
		st.add_uv(Vector2(0,0))
		st.add_vertex(play_area[3])
		st.add_uv(Vector2(1,0))
		st.add_vertex(play_area[3] + h)
		st.add_uv(Vector2(1,1))
		st.add_vertex(play_area[0] + h)
		st.add_uv(Vector2(0,0))
		st.add_vertex(play_area[3])
		st.add_uv(Vector2(1,1))
		st.add_vertex(play_area[0] + h)
		st.add_uv(Vector2(0,1))
		st.add_vertex(play_area[0])
		
		# side C
		st.add_uv(Vector2(0,0))
		st.add_vertex(play_area[1])
		st.add_uv(Vector2(1,0))
		st.add_vertex(play_area[1] + h)
		st.add_uv(Vector2(1,1))
		st.add_vertex(play_area[2] + h)
		st.add_uv(Vector2(0,0))
		st.add_vertex(play_area[1])
		st.add_uv(Vector2(1,1))
		st.add_vertex(play_area[2] + h)
		st.add_uv(Vector2(0,1))
		st.add_vertex(play_area[2])
		
		# side D
		st.add_uv(Vector2(0,0))
		st.add_vertex(play_area[2])
		st.add_uv(Vector2(1,0))
		st.add_vertex(play_area[2] + h)
		st.add_uv(Vector2(1,1))
		st.add_vertex(play_area[3] + h)
		st.add_uv(Vector2(0,0))
		st.add_vertex(play_area[2])
		st.add_uv(Vector2(1,1))
		st.add_vertex(play_area[3] + h)
		st.add_uv(Vector2(0,1))
		st.add_vertex(play_area[3])
		
		st.generate_normals()
		st.generate_tangents()
		
		# we've updated it
		mesh = st.commit()
		ws = new_ws
		reference = new_reference
